#!/usr/bin/python3
import sys
import codecs
import traceback
import requests
import re
import pandas as pd
import random
import urllib
import dataset
import json
import gspread
import datetime
from gspread_pandas import Spread, Client
from oauth2client.service_account import ServiceAccountCredentials
import os
import threading

def save_sheet(df,filename,tabname,startpos='A1'):

    scope = ['https://spreadsheets.google.com/feeds',
            'https://www.googleapis.com/auth/drive']

    credentials = ServiceAccountCredentials.from_json_keyfile_name('c:\\keys\\spread2.json', scope)
#    credentials = ServiceAccountCredentials.from_json_keyfile_name('/var/keys/spread2.json', scope)

    gc = gspread.authorize(credentials)
    spread = Spread(filename,creds=credentials)

    spread.df_to_sheet(df, index=False, sheet=tabname, start=startpos, replace=False)


def do_jobs():
    db = dataset.connect('mysql://choozmo:pAssw0rd@db.ptt.cx:3306/hhh?charset=utf8mb4')
    cursor=db.query("SELECT k1.query,k1.clicks,k1.impressions,k1.ctr,(k2.clicks-k1.clicks)/k1.clicks*100 as growth FROM hhh.hhh_weekly_keywords k1, hhh_weekly_keywords k2 where k1.weeknum='23' and k2.weeknum='24' and k1.query=k2.query order by (k2.clicks-k1.clicks)/k1.clicks*100 desc;")
    df = pd.DataFrame(columns=('query','clicks','impressions','ctr','growth'))

    idx=0

    for c in cursor:
        df.loc[idx]=[c['query'],c['clicks'],c['impressions'],c['ctr'],c['growth']]
    #    df.loc[idx]=['okok',333]
        idx+=1
    save_sheet(df,'WeeklyReport','keywords')

t = threading.Thread(target = do_jobs)
t.start()
t.join()

